﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace Numbers_only
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //adding some predefined chars that will be only allowed in third textBox
            listAllowedChars.Items.Add("@");
            listAllowedChars.Items.Add("#");
            listAllowedChars.Items.Add("$");
        }

        private void btnAddChar_Click(object sender, EventArgs e)
        {
            //although textBox has maxLenth set to only 1, additional check here is included just to demonstrate how simple validation can be performed
            if (txtBox_AddChar.Text.Length != 1)
            {
                MessageBox.Show("Please enter one char only");
                txtBox_AddChar.Focus();
                txtBox_AddChar.SelectAll();
                return; 
            }

            //if the entered character doesn't exist in the list, add it
            if (!listAllowedChars.Items.Contains(txtBox_AddChar.Text))
            {
                listAllowedChars.Items.Add(txtBox_AddChar.Text);
            }
            //else if it is already there, show message box, select the text inside so the user can edit it right away and focus the textBox
            // it is more for user experience rather than functioanlity
            else
            {
                MessageBox.Show("Char allready exist in the list");
                txtBox_AddChar.Focus();
                txtBox_AddChar.SelectAll();
            }
        }

        //event for handling numbers only
        //it allows entering digits, one decimal separator, and backspace for deleting
        private void txtBox_NumbersOnly_Press(object sender, KeyPressEventArgs e)
        {
            e.Handled = ((!char.IsDigit(e.KeyChar)) && (e.KeyChar != '\b'));
            char decimalSeparator = Convert.ToChar(CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator);
            if (e.KeyChar == decimalSeparator)
            {
                TextBox tb = sender as TextBox;
                e.Handled = tb.Text.Contains(decimalSeparator);
            }

        }

        //only characters added to the predefined list are allowed here
        private void txtBox_SpecialCharsOnly_Press(object sender, KeyPressEventArgs e)
        {
            e.Handled = !listAllowedChars.Items.Contains(e.KeyChar.ToString());
        }
    }
}
